commit d01c3def63caf59d1d156aec8d52a1540e5ffe27
Author: Marek Polacek <polacek@redhat.com>
Date:   Wed Sep 16 09:27:29 2020 -0400

    preprocessor: Fix ICE with too long line in fmtwarn [PR96935]
    
    Here we ICE in char_span::subspan because the offset it gets is -1.
    It's -1 because get_substring_ranges_for_loc gets a location whose
    column was 0.  That only happens in testcases like the attached where
    we're dealing with extremely long lines (at least 4065 chars it seems).
    This does happen in practice, though, so it's not just a theoretical
    problem (e.g. when building the SU2 suite).
    
    Fixed by checking that the column get_substring_ranges_for_loc gets is
    sane, akin to other checks in that function.
    
    gcc/ChangeLog:
    
            PR preprocessor/96935
            * input.c (get_substring_ranges_for_loc): Return if start.column
            is less than 1.
    
    gcc/testsuite/ChangeLog:
    
            PR preprocessor/96935
            * gcc.dg/format/pr96935.c: New test.
    
    (cherry picked from commit 31dd5cd6344bfbbe122fb512993b128e11236d35)

diff --git a/gcc/input.c b/gcc/input.c
index dd1d23df2f7..4a5e514b1f3 100644
--- a/gcc/input.c
+++ b/gcc/input.c
@@ -1461,6 +1461,8 @@ get_substring_ranges_for_loc (cpp_reader *pfile,
       size_t literal_length = finish.column - start.column + 1;
 
       /* Ensure that we don't crash if we got the wrong location.  */
+      if (start.column < 1)
+	return "zero start column";
       if (line.length () < (start.column - 1 + literal_length))
 	return "line is not wide enough";
 
